module dislin_mod2

public :: arcell, ax2grf, axclrs, axends, axgit , axslen, axsorg, axspos
public :: axstyp, barwth, basalf, bezier, box2d , btrini, center, chaang
public :: chnatt, chaspc, chawth, chncrv, chndot, chndsh, circle, circsp
public :: clpbor, clpmod, clpwin, clrcyc, clrmod, color , comgot, connpt
public :: cross , dash  , dashl , dashm , daxgit, dcross,         dnumqq
public :: dot   , dotl  , ellips, elpsln, eushft, fcha  , flen  , filbox
public :: filclr, filmod, fixspc, frame , frmess, gapcrv, gaxsop, getang
public :: getbpp, getaxc, getcen, getclp, getclr, getdig, getdsp, getfil
public :: getgrc, getgrf, gethgt, getlab, getlen, getlev, getlin, getmfl
public :: getor , getpag, getpat, getpos, getscl, getsp1, getsp2, getsym
public :: gettcl, gettic, gettyp, getuni, getvk , getwin, getxid, gnustr
public :: grace , grdpol, grid  , hidlin, hname , hsymbl, htitle, hwfont
public :: hworig, hwpage, iangle, inccrv, incfil, incmrk, inityp, intax 
public :: intcha, intlen, kdarc , labclr, labdis, labels, labjus, labpos
public :: labtyp, legclr, legopt, legpat, legpos, legtit, lfttit, lincyc
public :: linesp, linwid, lncap , lnjoin, lnmlt , logtic, marker, mixalf
public :: mixleg, moment, mylab , myline, mypat , namdis, name  , namjus
public :: newpag, newmix, nlnumb, noarln, nochek, noclip, nograf, noline
public :: number, numfmt, numode, origin, page  , pagera, paghdr, pagmod
public :: patcyc, penwid, pie   , polcrv, psfont, qqbl08, qqcut1, rectan
public :: reset , rgtlab, rlarc , rlarea, rlcirc, rlell , rline , rlmess
public :: rlnumb, rlpie , rlrec , rlrnd , rlsec , rlsymb, rlvec , rndrec
public :: rvynam,         sclfac, sclmod, scmplx, scrmod, sector, setbas
public :: setexp, setfil, setgrf, setmix, neglog, setpag, setscl, shdcha
public :: shdcrv, shlcir, shldel, shlell, shlind, shlpie, shlpol, shlvis
public :: smxalf, solid , sortr1, spline, splmod, strtpt, swapxy, symbol
public :: symrot, thkcrv, thklin, thklnx, ticks , ticlen, ticpos, tiforg
public :: tifwin, timopt, titjus, title , titlin, titpos, trfco1, trfco2
public :: trfco3, trfres, trfrot, trfscl, trfshf, trmlen, txtjus, unit  
public :: upstr , vector, vkytit, winmod, window, winsiz, x11mod, xaxgit
public :: xaxis , xaxlg , xcross, xinvrs, xpolyl, xposn , yaxgit, yaxis 
public :: yaxlg , ycross, yinvrs, yposn 
public :: labdig, axsscl, getrgb, field,  setrgb, setxid
  interface
 
! ================================= disbs1 ==============================
 
    subroutine arcell(nx,ny,na,nb,alpha,beta,theta)
      integer, intent (in) :: nx,ny,na,nb
      real, intent (in)   :: alpha,beta,theta
    end subroutine arcell
 
    subroutine ax2grf()
    end subroutine ax2grf
 
    subroutine axclrs(n,copt,cax)
      integer, intent(in) :: n
      character (len = *) , intent (in) :: copt, cax
    end subroutine axclrs
 
    subroutine axends(copt,cax)
      character (len = *) , intent (in) :: copt, cax
    end subroutine axends
 
    subroutine axgit()
    end subroutine axgit
 
    subroutine axslen(i,j)
      integer, intent (in) :: i,j
    end subroutine axslen
 
    subroutine axsorg(i,j)
      integer, intent (in) :: i,j
    end subroutine axsorg
 
    subroutine axspos(i,j)
      integer, intent (in) :: i,j
    end subroutine axspos
 
    subroutine axstyp(copt)
      character (len = *), intent (in) :: copt
    end subroutine axstyp
 
    subroutine barwth(fact)
      real, intent (in) :: fact
    end subroutine barwth
 
    subroutine basalf(calph)
      character (len = *), intent (in) :: calph
    end subroutine basalf
 
    subroutine bezier(xray,yray,nray,x,y,n)
      integer, intent (in)  :: nray,n
      real, dimension (:), intent (in)  :: xray, yray
      real, dimension (:), intent (out) :: x, y
    end subroutine bezier
 
    subroutine box2d()
    end subroutine box2d
 
    subroutine btrini()
    end subroutine btrini
 
    subroutine center()
    end subroutine center
 
    subroutine chaang(x)
      real, intent (in) :: x
    end subroutine chaang
 
    subroutine chnatt()
    end subroutine chnatt
 
    subroutine chaspc(x)
      real, intent (in) :: x
    end subroutine chaspc
 
    subroutine chawth(x)
      real, intent (in) :: x
    end subroutine chawth
 
    subroutine chncrv(copt)
      character (len = *), intent (in) :: copt
    end subroutine chncrv
 
    subroutine chndot()
    end subroutine chndot
 
    subroutine chndsh()
    end subroutine chndsh
 
    subroutine circle(nx,ny,nr)
      integer, intent (in) :: nx,ny,nr
    end subroutine circle
 
    subroutine circsp(n)
      integer, intent (in) :: n
    end subroutine circsp
 
    subroutine clpbor(copt)
      character (len = *), intent (in) :: copt
    end subroutine clpbor
 
    subroutine clpmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine clpmod
 
    subroutine clpwin(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine clpwin
 
    subroutine clrcyc(i,iclr)
      integer, intent (in) :: i,iclr
    end subroutine clrcyc
 
    subroutine clrmod(copt)
      character (len = *), intent (in) :: copt
    end subroutine clrmod
 
    subroutine color(copt)
      character (len = *), intent (in) :: copt
    end subroutine color
 
    subroutine comgot()
    end subroutine comgot
 
    subroutine connpt(x,y)
      real, intent (in) :: x,y
    end subroutine connpt
 
    subroutine cross()
    end subroutine cross
 
    subroutine dash()
    end subroutine dash
 
    subroutine dashl()
    end subroutine dashl
 
    subroutine dashm()
    end subroutine dashm
 
    subroutine daxgit(i)
      integer, intent (in) :: i
    end subroutine daxgit
 
    subroutine dcross(i)
      integer, intent (in) :: i
    end subroutine dcross
 
    subroutine labdig(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine labdig
 
    subroutine dnumqq(x,ndez,nx,ny)
      real, intent (in) :: x
      integer, intent (in) :: ndez,nx,ny
    end subroutine dnumqq
 
    subroutine dot()
    end subroutine dot
 
    subroutine dotl()
    end subroutine dotl
 
    subroutine ellips(nx,ny,na,nb)
      integer, intent (in) :: nx,ny,na,nb
    end subroutine ellips
 
    subroutine elpsln(nx,ny,na,nb,a,b,t,ilin,iopt)
      integer, intent (in) :: nx,ny,na,nb,ilin,iopt
      real, intent (in) :: a,b,t
    end subroutine elpsln
 
    subroutine eushft(calph,csft)
      character (len = *), intent (in) :: calph,csft
    end subroutine eushft
 
    subroutine fcha(x,ndez,nl,cstr)
      real, intent (in) :: x
      integer, intent (in) :: ndez
      integer, intent (out) :: nl
      character (len = *), intent (out) :: cstr
    end subroutine fcha
 
    subroutine field(xray,yray,uray,vray,n,ivec)
      real, dimension (:), intent (in) :: xray,yray,uray,vray
      integer, intent (in) :: n, ivec
    end subroutine field

    subroutine flen(x,ndez,nx)
      real, intent (in) :: x
      integer, intent (in) :: ndez
      integer, intent (out) :: nx
    end subroutine flen
 
    subroutine filbox(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine filbox
 
    subroutine filclr(copt)
      character (len = *), intent (in) :: copt
    end subroutine filclr
 
    subroutine filmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine filmod
 
    subroutine fixspc(x)
      real, intent (in) :: x
    end subroutine fixspc
 
    subroutine frame(i)
      integer, intent (in):: i
    end subroutine frame
 
    subroutine frmess(i)
      integer, intent (in):: i
    end subroutine frmess
 
    subroutine gapcrv(x)
      real, intent (in) :: x
    end subroutine gapcrv
 
    subroutine gaxsop(cax,n,i,j,k)
      character (len = *), intent (in) :: cax
      integer, intent (in)  :: n
      integer, intent (out) :: i,j,k
    end subroutine gaxsop
 
    subroutine getang(i)
      integer, intent (out) :: i
    end subroutine getang
 
    subroutine getbpp(i)
      integer, intent (out) :: i
    end subroutine getbpp
 
    subroutine getaxc(i)
      integer, intent (out) :: i
    end subroutine getaxc
 
    subroutine getcen(i)
      integer, intent (out) :: i
    end subroutine getcen
 
    subroutine getclp(nx,ny,nw,nh)
      integer, intent (out) :: nx,ny,nw,nh
    end subroutine getclp
 
    subroutine getclr(i)
      integer, intent (out) :: i
    end subroutine getclr
 
    subroutine getdig(i,j,k)
      integer, intent (out) :: i,j,k
    end subroutine getdig
 
    subroutine getdsp(cdsp)
      character (len = *), intent (out) :: cdsp
    end subroutine getdsp
 
    subroutine getfil(cstr)
      character (len = *), intent (out) :: cstr
    end subroutine getfil
 
    subroutine getgrc(i)
      integer, intent (out) :: i
    end subroutine getgrc
 
    subroutine getgrf(a,e,o,step,copt)
      real, intent (out) :: a,e,o,step
      character (len = *), intent (in) :: copt
    end subroutine getgrf
 
    subroutine gethgt(i)
      integer, intent (out) :: i
    end subroutine gethgt
 
    subroutine getlab(c1,c2,c3)
      character (len = *), intent (out) :: c1,c2,c3
    end subroutine getlab
 
    subroutine getlen(i,j,k)
      integer, intent (out) :: i,j,k
    end subroutine getlen
 
    subroutine getlev(i)
      integer, intent (out) :: i
    end subroutine getlev
 
    subroutine getlin(i)
      integer, intent (out) :: i
    end subroutine getlin
 
    subroutine getmfl(cstr)
      character (len = *), intent (out) :: cstr
    end subroutine getmfl
 
    subroutine getor(i,j)
      integer, intent (out) :: i,j
    end subroutine getor
 
    subroutine getpag(i,j)
      integer, intent (out) :: i,j
    end subroutine getpag
 
    subroutine getpat(i)
      integer, intent (out) :: i
    end subroutine getpat
 
    subroutine getpos(i,j)
      integer, intent (out) :: i,j
    end subroutine getpos
 
    subroutine getrgb(xr,xg,xb)
      real, intent (out) :: xr, xg, xb
    end subroutine getrgb

    subroutine getscl(i,j,k)
      integer, intent (out) :: i,j,k
    end subroutine getscl
 
    subroutine getsp1(i,j,k)
      integer, intent (out) :: i,j,k
    end subroutine getsp1
 
    subroutine getsp2(i,j,k)
      integer, intent (out) :: i,j,k
    end subroutine getsp2
 
    subroutine getsym(i,j)
      integer, intent (out) :: i,j
    end subroutine getsym
 
    subroutine gettcl(i,j)
      integer, intent (out) :: i,j
    end subroutine gettcl
 
    subroutine gettic(i,j,k)
      integer, intent (out) :: i,j,k
    end subroutine gettic
 
    subroutine gettyp(i)
      integer, intent (out) :: i
    end subroutine gettyp
 
    subroutine getuni(i)
      integer, intent (out) :: i
    end subroutine getuni
 
    subroutine getvk(i,j,k)
      integer, intent (out) :: i,j,k
    end subroutine getvk
 
    subroutine getwin(ix,iy,nw,nh)
      integer, intent (out) :: ix,iy,nw,nh
    end subroutine getwin
 
    subroutine getxid (ival, copt)
      integer, intent (out) :: ival
      character (len = *), intent (in) :: copt
    end subroutine getxid
 
    subroutine gnustr(ct,nl,cmod)
      integer, intent (in) :: nl
      character (len = *), intent (in)  :: cmod
      character (len = *), intent (out) :: ct
    end subroutine gnustr
 
    subroutine grace(i)
      integer, intent (in) :: i
    end subroutine grace
 
    subroutine grdpol(igrd,jgrd)
      integer, intent (in) :: igrd,jgrd
    end subroutine grdpol
 
    subroutine grid(i,j)
      integer, intent (in) :: i,j
    end subroutine grid
 
    subroutine hidlin(copt)
      character (len = *), intent (in) :: copt
    end subroutine hidlin
 
    subroutine hname(i)
      integer, intent (in) :: i
    end subroutine hname
 
    subroutine hsymbl(i)
      integer, intent (in) :: i
    end subroutine hsymbl
 
    subroutine htitle(i)
      integer, intent (in) :: i
    end subroutine htitle
 
    subroutine hwfont()
    end subroutine hwfont
 
    subroutine hworig(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine hworig
 
    subroutine hwpage(nxp,nyp)
      integer, intent (in) :: nxp,nyp
    end subroutine hwpage
 
    subroutine iangle(n)
      integer, intent (in) :: n
    end subroutine iangle
 
    subroutine inccrv(i)
      integer, intent (in) :: i
    end subroutine inccrv
 
    subroutine incfil(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine incfil
 
    subroutine incmrk(i)
      integer, intent (in) :: i
    end subroutine incmrk
 
    subroutine inityp()
    end subroutine inityp
 
    subroutine intax()
    end subroutine intax
 
    subroutine intcha(num,n,cnum)
      integer, intent (in)  :: num
      integer, intent (out) :: n
      character (len = *), intent (out) :: cnum
    end subroutine intcha
 
    subroutine intlen(nm,nlaen)
      integer, intent (in)  :: nm
      integer, intent (out) :: nlaen
    end subroutine intlen
 
    subroutine kdarc(nx,ny,nr,nr1,alpha,beta,nclr)
      integer, intent (in) :: nx,ny,nr,nr1,nclr
      real, intent (in) :: alpha,beta
    end subroutine kdarc
 
    subroutine labclr(iclr,copt)
      integer, intent (in) :: iclr
      character (len = *), intent (in) :: copt
    end subroutine labclr
 
    subroutine labdis(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine labdis
 
    subroutine labels(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labels
 
    subroutine labjus(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labjus
 
    subroutine labpos(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labpos
 
    subroutine labtyp(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine labtyp
 
    subroutine legclr()
    end subroutine legclr
 
    subroutine legopt(x1,x2,x3)
      real, intent (in) :: x1,x2,x3
    end subroutine legopt
 
    subroutine legpat(ilin,ithk,isym,iclr,ipat,i)
      integer, intent (in) :: ilin,ithk,isym,iclr,ipat,i
    end subroutine legpat
 
    subroutine legpos(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine legpos
 
    subroutine legtit(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine legtit
 
    subroutine lfttit()
    end subroutine lfttit
 
    subroutine lincyc(i,ilin)
      integer, intent (in) :: i,ilin
    end subroutine lincyc
 
    subroutine linesp(x)
      real, intent (in) :: x
    end subroutine linesp
 
    subroutine linwid(i)
      integer, intent (in) :: i
    end subroutine linwid
 
    subroutine lncap(copt)
      character (len = *), intent (in) :: copt
    end subroutine lncap
 
    subroutine lnjoin(copt)
      character (len = *), intent (in) :: copt
    end subroutine lnjoin
 
    subroutine lnmlt(x)
      real, intent (in) :: x
    end subroutine lnmlt
 
    subroutine logtic(copt)
      character (len = *), intent (in) :: copt
    end subroutine logtic
 
! ================================= disbs2 ==============================
 
    subroutine marker(i)
      integer, intent (in) :: i
    end subroutine marker
 
    subroutine mixalf()
    end subroutine mixalf
 
    subroutine mixleg()
    end subroutine mixleg
 
    subroutine moment(xray,n,copt,xv)
      real, dimension (:), intent (in) :: xray
      integer, intent (in) :: n
      character (len = *), intent (in) :: copt
      real, intent (out) :: xv
    end subroutine moment
 
    subroutine mylab(cstr,i,cax)
      character (len = *), intent (in) :: cstr,cax
      integer, intent (in) :: i
    end subroutine mylab
 
    subroutine myline(nray,n)
      integer, dimension (:), intent (in) :: nray
      integer, intent (in) :: n
    end subroutine myline
 
    subroutine mypat(iang,itype,idens,icross)
      integer, intent (in) :: iang,itype,idens,icross
    end subroutine mypat
 
    subroutine namdis(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine namdis
 
    subroutine name(cnam,cax)
      character (len = *), intent (in) :: cnam,cax
    end subroutine name
 
    subroutine namjus(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine namjus
 
    subroutine newpag()
    end subroutine newpag
 
    subroutine newmix()
    end subroutine newmix
 
    function nlnumb(x,ndez) result (iret)
      real, intent (in) :: x
      integer, intent (in) :: ndez
      integer :: iret
    end function nlnumb

    subroutine noarln()
    end subroutine noarln
 
    subroutine nochek()
    end subroutine nochek
 
    subroutine noclip()
    end subroutine noclip
 
    subroutine nograf()
    end subroutine nograf
 
    subroutine noline(cax)
      character (len = *), intent (in) :: cax
    end subroutine noline
 
    subroutine number(x,ndez,nx,ny)
      real, intent (in) :: x
      integer, intent (in) :: ndez,nx,ny
    end subroutine number
 
    subroutine numfmt(ct)
      character (len = *), intent (in) :: ct
    end subroutine numfmt
 
    subroutine numode(cdec,cgrp,cpos,cspc)
      character (len = *), intent (in) :: cdec,cgrp,cpos,cspc
    end subroutine numode
 
    subroutine origin(i,j)
      integer, intent (in) :: i,j
    end subroutine origin
 
    subroutine page(nxp,nyp)
      integer, intent (in) :: nxp,nyp
    end subroutine page
 
    subroutine pagera()
    end subroutine pagera
 
    subroutine paghdr(c1,c2,iopt,idir)
      character (len = *), intent (in) :: c1,c2
      integer, intent (in) :: iopt,idir
    end subroutine paghdr
 
    subroutine pagmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine pagmod
 
    subroutine patcyc(i,ipat)
      integer, intent (in) :: i,ipat
    end subroutine patcyc
 
    subroutine penwid(x)
      real, intent (in) :: x
    end subroutine penwid
 
    subroutine pie(nx,ny,nr,a,b)
      integer, intent (in) :: nx,ny,nr
      real, intent (in) :: a,b
    end subroutine pie
 
    subroutine polcrv(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine polcrv
 
    subroutine psfont(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine psfont
 
    subroutine qqbl08(x,y,n,off)
      real, dimension (:), intent (in) :: x,y
      integer, intent (in) :: n
      real, intent (in) :: off
    end subroutine qqbl08
 
    subroutine qqcut1(x1,y1,x2,y2,a,b,xs,ys,is)
      real, intent (in) :: x1,y1,x2,y2,a,b
      real, intent (out) :: xs,ys
      integer, intent (out) :: is
    end subroutine qqcut1
 
    subroutine rectan(nx,ny,nb,nh)
      integer, intent (in) :: nx,ny,nb,nh
    end subroutine rectan
 
    subroutine reset(cw)
      character (len = *), intent (in) :: cw
    end subroutine reset
 
    subroutine rgtlab()
    end subroutine rgtlab
 
    subroutine rlarc(xm,ym,a,b,alpha,beta,theta)
      real, intent (in) :: xm,ym,a,b,alpha,beta,theta
    end subroutine rlarc
 
    subroutine rlarea(x,y,n)
      real, dimension (:), intent (in) :: x,y
      integer, intent (in) :: n
    end subroutine rlarea
 
    subroutine rlcirc(xm,ym,r)
      real, intent (in) :: xm,ym,r
    end subroutine rlcirc
 
    subroutine rlell(xm,ym,a,b)
      real, intent (in) :: xm,ym,a,b
    end subroutine rlell
 
    subroutine rline(x,y,u,v)
      real, intent (in) :: x,y,u,v
    end subroutine rline
 
    subroutine rlmess(cstr,x,y)
      character (len = *), intent (in) :: cstr
      real, intent (in) :: x,y
    end subroutine rlmess
 
    subroutine rlnumb(z,ndez,x,y)
      real, intent (in) :: z,x,y
      integer, intent (in) :: ndez
    end subroutine rlnumb
 
    subroutine rlpie(xm,ym,r,alpha,beta)
      real, intent (in) :: xm,ym,r,alpha,beta
    end subroutine rlpie
 
    subroutine rlrec(x,y,xb,xh)
      real, intent (in) :: x,y,xb,xh
    end subroutine rlrec
 
    subroutine rlrnd(x,y,xb,xh,irnd)
      real, intent (in) :: x,y,xb,xh
      integer, intent (in) :: irnd
    end subroutine rlrnd
 
    subroutine rlsec(xm,ym,r1,r,beta,alpha,ncol)
      real, intent (in) :: xm,ym,r1,r,beta,alpha
      integer, intent (in) :: ncol
    end subroutine rlsec
 
    subroutine rlsymb(i,x,y)
      integer, intent (in) :: i
      real, intent (in) :: x,y
    end subroutine rlsymb
 
    subroutine rlvec(x,y,u,v,ivec)
      real, intent (in) :: x,y,u,v
      integer, intent (in) :: ivec
    end subroutine rlvec
 
    subroutine rndrec(nx,ny,nb,nh,irnd)
      integer, intent (in) :: nx,ny,nb,nh,irnd
    end subroutine rndrec
 
    subroutine rvynam()
    end subroutine rvynam
 
    subroutine axsscl(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine axsscl
 
    subroutine sclfac(x)
      real, intent (in) :: x
    end subroutine sclfac
 
    subroutine sclmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine sclmod
 
    subroutine scmplx()
    end subroutine scmplx
 
    subroutine scrmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine scrmod
 
    subroutine sector(nx,ny,nr1,nr2,alpha,beta,ncol)
      integer, intent (in) :: nx,ny,nr1,nr2,ncol
      real, intent (in) :: alpha,beta
    end subroutine sector
 
    subroutine setbas(f)
      real, intent (in) :: f
    end subroutine setbas
 
    subroutine setexp(f)
      real, intent (in) :: f
    end subroutine setexp
 
    subroutine setfil(ct)
      character (len = *), intent (in) :: ct
    end subroutine setfil
 
    subroutine setgrf(c1,c2,c3,c4)
      character (len = *), intent (in) :: c1,c2,c3,c4
    end subroutine setgrf
 
    subroutine setmix(c,cstr)
      character (len = *), intent (in) :: c,cstr
    end subroutine setmix
 
    subroutine neglog(e)
      real, intent (in) :: e
    end subroutine neglog
 
    subroutine setpag(ct)
      character (len = *), intent (in) :: ct
    end subroutine setpag
 
    subroutine setrgb(xr,xg,xb)
      real, intent (in) :: xr,xg,xb
    end subroutine setrgb

    subroutine setscl(xray,n,cstr)
      real, dimension (:), intent (in) :: xray
      integer, intent (in) :: n
      character (len = *), intent (in) :: cstr
    end subroutine setscl
 
    subroutine setxid(i,copt)
      integer, intent (in) :: i
      character (len = *), intent (in) :: copt
    end subroutine setxid

    subroutine shdcha()
    end subroutine shdcha
 
    subroutine shdcrv(x1,y1,n1,x2,y2,n2)
      real, dimension (:), intent (in) :: x1,y1,x2,y2
      integer, intent (in) :: n1,n2
    end subroutine shdcrv
 
    subroutine shlcir(nx,ny,nr)
      integer, intent (in) :: nx,ny,nr
    end subroutine shlcir
 
    subroutine shldel(id)
      integer, intent (in) :: id
    end subroutine shldel
 
    subroutine shlell(nx,ny,na,nb,ang)
      integer, intent (in) :: nx,ny,na,nb
      real, intent (in) :: ang
    end subroutine shlell
 
    subroutine shlind(id)
      integer, intent (out) :: id
    end subroutine shlind
 
    subroutine shlpie(nx,ny,nr,alph,beta)
      integer, intent (in) :: nx,ny,nr
      real, intent (in) :: alph,beta
    end subroutine shlpie
 
    subroutine shlpol(nxray,nyray,n)
      integer, dimension (:), intent (in) :: nxray,nyray
      integer, intent (in) :: n
    end subroutine shlpol
 
    subroutine shlvis(id,cvis)
      integer, intent (in) :: id
      character (len = *), intent (in) :: cvis
    end subroutine shlvis
 
    subroutine smxalf(calph,ca,cb,n)
      character (len = *), intent (in) :: calph,ca,cb
      integer, intent (in) :: n
    end subroutine smxalf
 
    subroutine solid()
    end subroutine solid
 
    subroutine sortr1(x,n,copt)
      real, dimension (:), intent (in out) :: x
      integer, intent (in) :: n
      character (len = *), intent (in) :: copt
    end subroutine sortr1
 
    subroutine spline(x,y,n,xray,yray,ndat)
      real, dimension (:),intent (in) :: x,y
      integer, intent (in) :: n
      real, dimension (:),intent (out) :: xray,yray
      integer, intent (out) :: ndat
    end subroutine spline
 
    subroutine splmod(k,n)
      integer, intent (in) :: k,n
    end subroutine splmod
 
    subroutine strtpt(x,y)
      real, intent (in) :: x,y
    end subroutine strtpt
 
    subroutine swapxy(i,j)
      integer, intent (in) :: i,j
    end subroutine swapxy
 
    subroutine symbol(i,nx,ny)
      integer, intent (in) :: i,nx,ny
    end subroutine symbol
 
    subroutine symrot(xrot)
      real, intent (in) :: xrot
    end subroutine symrot
 
    subroutine thkcrv(i)
      integer, intent (in) :: i
    end subroutine thkcrv
 
    subroutine thklin(ix,iy,iu,iv)
      integer, intent (in) :: ix,iy,iu,iv
    end subroutine thklin
 
    subroutine thklnx(x,y,u,v)
      real, intent (in) :: x,y,u,v
    end subroutine thklnx
 
    subroutine ticks(i,cax)
      integer, intent (in) :: i
      character (len = *), intent (in) :: cax
    end subroutine ticks
 
    subroutine ticlen(i1,i2)
      integer, intent (in) :: i1,i2
    end subroutine ticlen
 
    subroutine ticpos(copt,cax)
      character (len = *), intent (in) :: copt,cax
    end subroutine ticpos
 
    subroutine tiforg(nx,ny)
      integer, intent (in) :: nx,ny
    end subroutine tiforg
 
    subroutine tifwin(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine tifwin
 
    subroutine timopt()
    end subroutine timopt
 
    subroutine titjus(copt)
      character (len = *), intent (in) :: copt
    end subroutine titjus
 
    subroutine title()
    end subroutine title
 
    subroutine titlin(cstr,j)
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: j
    end subroutine titlin
 
    subroutine titpos(copt)
      character (len = *), intent (in) :: copt
    end subroutine titpos
 
    subroutine trfco1(xray,n,cfrom,cto)
      real, dimension (:), intent (in out) :: xray
      integer, intent (in) :: n
      character (len = *), intent(in) :: cfrom, cto
    end subroutine trfco1
 
    subroutine trfco2(xray,yray,n,cfrom,cto)
      real, dimension (:), intent (in out) :: xray,yray
      integer, intent (in) :: n
      character (len = *), intent(in) :: cfrom, cto
    end subroutine trfco2
 
    subroutine trfco3(xray,yray,zray,n,cfrom,cto)
      real, dimension (:), intent (in out) :: xray,yray,zray
      integer, intent (in) :: n
      character (len = *), intent(in) :: cfrom, cto
    end subroutine trfco3
 
    subroutine trfres()
    end subroutine trfres
 
    subroutine trfrot(xang,nx,ny)
      real, intent (in) :: xang
      integer, intent (in) :: nx,ny
    end subroutine trfrot
 
    subroutine trfscl(xscl,yscl)
      real, intent (in) :: xscl,yscl
    end subroutine trfscl
 
    subroutine trfshf(nxshf,nyshf)
      integer, intent (in) :: nxshf,nyshf
    end subroutine trfshf
 
    function trmlen(cstr) result (xret)
      character (len = *), intent (in) :: cstr
      real :: xret
    end function trmlen
 
    subroutine txtjus(copt)
      character (len = *), intent (in) :: copt
    end subroutine txtjus
 
    subroutine unit(i)
      integer, intent (in) :: i
    end subroutine unit
 
    subroutine upstr(cstr)
      character (len = *), intent (in out) :: cstr
    end subroutine upstr
 
    subroutine vector(ix1,iy1,ix2,iy2,ivec)
      integer, intent (in) :: ix1,iy1,ix2,iy2,ivec
    end subroutine vector
 
    subroutine vkytit(i)
      integer, intent (in) :: i
    end subroutine vkytit
 
    subroutine winmod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine winmod
 
    subroutine window(nx,ny,nw,nh)
      integer, intent (in) :: nx,ny,nw,nh
    end subroutine window
 
    subroutine winsiz(nw,nh)
      integer, intent (in) :: nw,nh
    end subroutine winsiz
 
    subroutine x11mod(cmod)
      character (len = *), intent (in) :: cmod
    end subroutine x11mod
 
    subroutine xaxgit()
    end subroutine xaxgit
 
    subroutine xaxis(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine xaxis
 
    subroutine xaxlg(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine xaxlg
 
    subroutine xcross()
    end subroutine xcross
 
    function xinvrs(i) result (xret)
      integer, intent (in) :: i
      real :: xret
    end function xinvrs
 
    subroutine xpolyl(xray,yray,n)
      real, dimension (:), intent (in) :: xray,yray
      integer, intent (in) :: n
    end subroutine xpolyl
 
    function xposn(x) result (xret)
      real, intent (in) :: x
      real :: xret
    end function xposn
 
    subroutine yaxgit()
    end subroutine yaxgit
 
    subroutine yaxis(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine yaxis
 
    subroutine yaxlg(a,b,o,step,il,cstr,it,ix,iy)
      real, intent (in) :: a,b,o,step
      character (len = *), intent (in) :: cstr
      integer, intent (in) :: il,it,ix,iy
    end subroutine yaxlg
 
    subroutine ycross()
    end subroutine ycross
 
    function yinvrs(i) result (xret) 
      integer, intent (in) :: i
      real :: xret
    end function yinvrs
 
    function yposn(y) result (xret)
      real, intent (in) :: y
      real :: xret
    end function yposn
  end interface
end module dislin_mod2
