module dislin_mod3

public :: autres, ax3len, axis3d, bargrp
public :: barpos, bartyp, box3d , chabox, chnpie, ckpktx, ckpkty, colran
public :: colray, conang, concrv, congap, conlab, conmat, conmod, crvmat
public :: curv3d, curve3, curvmp, curvx3, curvy3, errbar, expzlb, flab3d
public :: getind, getmat, getran, getres, getvlt, getwid, grid3d, gridmp
public :: histog, hsvrgb, map   , mapdta, mapfil, mapmod, mappol, mapref
public :: mapsph, mdfmat, mypie , myvlt , ncollg, ncolor, nobar , nobgd 
public :: nohide, pieexp, pielab, pievec, point , pointx, projct, recfll
public :: rel3pt, rgbhsv, rlpoin, setind, setres, shdeur, shdmap, shdmod
public :: shlsur, surclr, surfce,                 surmat, surshd, sursze
public :: survis, usrpie, vectr3, view3d, vkxbar, vkybar, widbar, world 
public :: x2dpos, x3dpos, x3drel, xaxmap, y2dpos, y3dpos, y3drel, yaxmap
public :: z3dpos, zaxis , zaxlg , zscale, zbflin, zbftri
public :: clip3d, surmsh, vang3d, vclp3d, vfoc3d, vup3d,  zbfini, zbffin
! public :: surfun, zfun
  interface
 

! ================================= disext ==============================
 
    subroutine autres(i,j)
      integer, intent (in) :: i,j
    end subroutine autres
 
    subroutine ax3len(i,j,k)
      integer, intent (in) :: i,j,k
    end subroutine ax3len
 
    subroutine axis3d(x,y,z)
      real, intent (in) :: x,y,z
    end subroutine axis3d
 
    subroutine bargrp(n,xgap)
      integer, intent (in) :: n
      real, intent (in) :: xgap
    end subroutine bargrp
 
    subroutine barpos(cpos)
      character (len = *), intent (in) :: cpos
    end subroutine barpos
 
    subroutine bartyp(ctyp)
      character (len = *), intent (in) :: ctyp
    end subroutine bartyp
 
    subroutine box3d()
    end subroutine box3d
 
    subroutine chabox()
    end subroutine chabox
 
    subroutine chnpie(copt)
      character (len = *), intent (in) :: copt
    end subroutine chnpie
 
    subroutine ckpktx(x,ichk)
      real, intent (in) :: x
      integer, intent (out) :: ichk
    end subroutine ckpktx
 
    subroutine ckpkty(y,ichk)
      real, intent (in) :: y
      integer, intent (out) :: ichk
    end subroutine ckpkty
 
    subroutine clip3d(ctyp)
      character (len = *), intent (in) :: ctyp
    end subroutine clip3d

    subroutine colran(i,j)
      integer, intent (in) :: i,j
    end subroutine colran
 
    subroutine colray(z,ncol,n)
      real, dimension (:), intent (in) :: z
      integer, dimension (:), intent (out) :: ncol
      integer, intent (in) :: n
    end subroutine colray
 
    subroutine conang(xang)
      real, intent (in) :: xang
    end subroutine conang
 
    subroutine concrv(x,y,n,zlev)
      real, dimension (:), intent (in) :: x,y
      integer, intent (in) :: n
      real, intent (in) :: zlev
    end subroutine concrv
 
    subroutine congap(xgap)
      real, intent (in) :: xgap
    end subroutine congap
 
    subroutine conlab(cstr)
      character (len = *), intent (in) :: cstr
    end subroutine conlab
 
    subroutine conmat(zmat,n,m,zlev)
      real, dimension (:,:), intent (in) :: zmat
      integer, intent (in) :: n,m
      real, intent (in) :: zlev
    end subroutine conmat
 
    subroutine conmod (xf1,xf2)
      real, intent (in) :: xf1,xf2
    end subroutine conmod
 
    subroutine crvmat(zmat,ixdim,iydim,ixpts,iypts)
      real, dimension (:,:), intent (in) :: zmat
      integer, intent (in) :: ixdim,iydim,ixpts,iypts
    end subroutine crvmat
 
    subroutine curv3d(x,y,z,n)
      real, dimension (:), intent (in) :: x,y,z
      integer, intent (in) :: n
    end subroutine curv3d
 
    subroutine curve3(x,y,z,n)
      real, dimension (:), intent (in) :: x,y,z
      integer, intent (in) :: n
    end subroutine curve3
 
    subroutine curvmp(x,y,n)
      real, dimension (:), intent (in) :: x,y
      integer, intent (in) :: n
    end subroutine curvmp
 
    subroutine curvx3(x,y,z,n)
      real, dimension (:), intent (in) :: x,z
      real, intent (in) :: y
      integer, intent (in) :: n
    end subroutine curvx3
 
    subroutine curvy3(x,y,z,n)
      real, dimension (:), intent (in) :: y,z
      real, intent (in) :: x
      integer, intent (in) :: n
    end subroutine curvy3
 
    subroutine errbar(x,y,err1,err2,n)
      real, dimension (:), intent (in) :: x,y,err1,err2
      integer, intent (in) :: n
    end subroutine errbar
 
    subroutine expzlb(copt)
      character (len = *), intent (in) :: copt
    end subroutine expzlb
 
    subroutine flab3d()
    end subroutine flab3d
 
    subroutine getind(i,xr,xg,xb)
      integer, intent (in) :: i
      real, intent (out) :: xr,xg,xb
    end subroutine getind
 
    subroutine getmat(x,y,z,n,zmat,nx,ny,zval,imat,wmat)
      real, dimension (:), intent (in) :: x,y,z
      integer, intent (in) :: n,nx,ny
      real, dimension (:,:), intent (out) :: zmat
      real, intent (in) :: zval
      integer, dimension (:,:), intent (in out) :: imat
      real, dimension (:,:), intent (in out) :: wmat
    end subroutine getmat
 
    subroutine getran(i,j)
      integer, intent (out) :: i,j
    end subroutine getran
 
    subroutine getres(i,j)
      integer, intent (out) :: i,j
    end subroutine getres
 
    subroutine getvlt(ctab)
      character (len = *), intent (out) :: ctab
    end subroutine getvlt
 
    subroutine getwid(i)
      integer, intent (out) :: i
    end subroutine getwid
 
    subroutine grid3d(igrid,jgrid,copt)
      integer, intent (in) :: igrid,jgrid
      character (len = *), intent (in) :: copt
    end subroutine grid3d
 
    subroutine gridmp(i,j)
      integer, intent (in) :: i,j
    end subroutine gridmp
 
    subroutine histog(xray,n,x,y,m)
      real, dimension (:), intent (in) :: xray
      integer, intent (in) :: n
      real, dimension (:), intent (out) :: x,y
      integer, intent (out) :: m
    end subroutine histog
 
    subroutine hsvrgb(xh,xs,xv,r,g,b)
      real, intent (in)  :: xh,xs,xv
      real, intent (out) :: r,g,b
    end subroutine hsvrgb
 
    subroutine map(ct,copt)
      character (len = *), intent (in) :: ct,copt
    end subroutine map
 
    subroutine mapdta(ifil)
      integer, intent (in) :: ifil
    end subroutine mapdta
 
    subroutine mapfil(ct)
      character (len = *), intent (in) :: ct
    end subroutine mapfil
 
    subroutine mapmod(copt)
      character (len = *), intent (in) :: copt
    end subroutine mapmod
 
    subroutine mappol(x,y)
      real, intent (in) :: x,y
    end subroutine mappol
 
    subroutine mapref(ylw,yup)
      real, intent (in) :: ylw,yup
    end subroutine mapref
 
    subroutine mapsph(xrad)
      real, intent (in) :: xrad
    end subroutine mapsph
 
    subroutine mdfmat(i,j,x)
      integer, intent (in) :: i,j
      real, intent (in) :: x
    end subroutine mdfmat
 
    subroutine mypie(iseg,xdat,xper,nrad,noff,angle,nvbox,idrw,iann)
      integer, intent (in out) :: iseg,nrad,noff,nvbox,idrw,iann
      real, intent (in out)    :: xdat,xper,angle
    end subroutine mypie
 
    subroutine myvlt(xr,xg,xb,n)
      real, dimension (:), intent (in) :: xr,xg,xb
      integer, intent (in) :: n
    end subroutine myvlt
 
    function ncollg(z) result (iret)
      real, intent (in) :: z
      integer :: iret
    end function ncollg
 
    function ncolor(z) result (iret)
      real, intent (in) :: z
      integer :: iret
    end function ncolor
 
    subroutine nobar()
    end subroutine nobar
 
    subroutine nobgd()
    end subroutine nobgd
 
    subroutine nohide()
    end subroutine nohide
 
    subroutine pieexp()
    end subroutine pieexp
 
    subroutine pielab(cdat,cstr)
      character(len = *), intent (in) :: cdat,cstr
    end subroutine pielab
 
    subroutine pievec(ivec,copt)
      integer, intent (in) :: ivec
      character (len = *), intent (in) :: copt
    end subroutine pievec
 
    subroutine point(nx,ny,nb,nh,ncol)
      integer, intent (in) :: nx,ny,nb,nh,ncol
    end subroutine point
 
    subroutine pointx(x,y,nb,nh,ncol)
      real, intent (in) :: x,y
      integer, intent (in) :: nb,nh,ncol
    end subroutine pointx
 
    subroutine projct(copt)
      character (len = *), intent (in) :: copt
    end subroutine projct
 
    subroutine recfll(nx,ny,nb,nh,ncol)
      integer, intent (in) :: nx,ny,nb,nh,ncol
    end subroutine recfll
 
    subroutine rel3pt(x,y,z,xp,yp)
      real, intent (in) :: x,y,z
      real, intent (out) :: xp,yp
    end subroutine rel3pt
 
    subroutine rgbhsv(r,g,b,xh,xs,xv)
      real, intent (in) :: r,g,b
      real, intent (out) :: xh,xs,xv
    end subroutine rgbhsv
 
    subroutine rlpoin(x,y,nb,nh,ncol)
      real, intent (in) :: x,y
      integer, intent (in) :: nb,nh,ncol
    end subroutine rlpoin
 
    subroutine setind(i,xr,xg,xb)
      integer, intent (in) :: i
      real, intent (in) :: xr,xg,xb
    end subroutine setind
 
    subroutine setres(i,j)
      integer, intent (in) :: i,j
    end subroutine setres
 
    subroutine shdeur(inat,ishd,iclr,n)
      integer, dimension (:), intent (in) :: inat,ishd,iclr
      integer, intent (in) :: n
    end subroutine shdeur
 
    subroutine shdmap(cmap)
      character (len = *), intent (in) :: cmap
    end subroutine shdmap
 
    subroutine shdmod(copt,ctype)
      character (len = *), intent (in) :: copt,ctype
    end subroutine shdmod
 
    subroutine shlsur()
    end subroutine shlsur
 
    subroutine surclr(itop,ibot)
      integer, intent (in) :: itop,ibot
    end subroutine surclr
 
    subroutine surfce(xray,ixdim,yray,iydim,zmat)
      real, dimension (:), intent (in) :: xray,yray
      integer, intent (in) :: ixdim,iydim
      real, dimension (:,:), intent (in) :: zmat
    end subroutine surfce
 
!    subroutine surfun(zfun,ixpts,xdel,iypts,ydel)
!      interface
!         function zfun(x,y)
!           real, intent (in) :: x,y
!           real :: zfun
!         end function zfun
!      end interface
!      integer, intent (in) :: ixpts,iypts
!      real, intent (in) :: xdel,ydel
!    end subroutine surfun
 
    subroutine surmat(zmat,ixdim,iydim,ixp,iyp)
      integer, intent (in) :: ixdim,iydim,ixp,iyp
      real, dimension (:,:), intent (in) :: zmat
    end subroutine surmat

    subroutine surmsh(copt)
      character (len = *), intent (in) :: copt
    end subroutine surmsh
 
    subroutine surshd(xray,ixdim,yray,iydim,zmat)
      real, dimension (:), intent (in) :: xray,yray
      integer, intent (in) :: ixdim,iydim
      real, dimension (:,:), intent (in) :: zmat
    end subroutine surshd
 
    subroutine sursze(ax,ex,ay,ey)
      real, intent (in) :: ax,ex,ay,ey
    end subroutine sursze
 
    subroutine survis(copt)
      character (len = *), intent (in) :: copt
    end subroutine survis
 
    subroutine usrpie(iseg,xdat,xper,nrad,noff,angle,nvbox,idrw,iann)
      integer, intent (in out) :: iseg,nrad,noff,nvbox,idrw,iann
      real,    intent (in out) :: xdat,xper,angle
    end subroutine usrpie
 
    subroutine vang3d(a)
      real, intent (in) :: a
    end subroutine vang3d

    subroutine vclp3d(x1,x2)
      real, intent (in) :: x1,x2
    end subroutine vclp3d

    subroutine vectr3(x1,y1,z1,x2,y2,z2,ivec)
      real, intent (in) :: x1,y1,z1,x2,y2,z2
      integer, intent (in) :: ivec
    end subroutine vectr3
 
    subroutine view3d(x,y,z,cview)
      real, intent (in) :: x,y,z
      character (len = *), intent (in) :: cview
    end subroutine view3d
 
    subroutine vfoc3d(x,y,z,cview)
      real, intent (in) :: x,y,z
      character (len = *), intent (in) :: cview
    end subroutine vfoc3d
 
    subroutine vkxbar(i)
      integer, intent (in) :: i
    end subroutine vkxbar
 
    subroutine vkybar(i)
      integer, intent (in) :: i
    end subroutine vkybar

    subroutine vup3d(a)
      real, intent (in) :: a
    end subroutine vup3d

    subroutine widbar(i)
      integer, intent (in) :: i
    end subroutine widbar
 
    subroutine world()
    end subroutine world
 
    function x2dpos(x,y) result (xret)
      real, intent (in) :: x,y
      real :: xret
    end function x2dpos
 
    function x3dpos(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function x3dpos
 
    function x3drel(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function x3drel
 
    subroutine xaxmap(a,b,o,step,cstr,it,iy)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: it,iy
      character (len = *), intent (in) :: cstr
    end subroutine xaxmap
 
    function y2dpos(x,y) result (xret)
      real, intent (in) :: x,y
      real :: xret
    end function y2dpos
 
    function y3dpos(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function y3dpos
 
    function y3drel(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function y3drel
 
    subroutine yaxmap(a,b,o,step,cstr,it,ix)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: it,ix
      character (len = *), intent (in) :: cstr
    end subroutine yaxmap
 
    function z3dpos(x,y,z) result (xret)
      real, intent (in) :: x,y,z
      real :: xret
    end function z3dpos
 
    subroutine zaxis(a,b,o,step,il,cstr,it,idir,ix,iy)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: il,it,idir,ix,iy
      character (len = *), intent (in) :: cstr
    end subroutine zaxis
 
    subroutine zaxlg(a,b,o,step,il,cstr,it,idir,ix,iy)
      real, intent (in) :: a,b,o,step
      integer, intent (in) :: il,it,idir,ix,iy
      character (len = *), intent (in) :: cstr
    end subroutine zaxlg
 
    subroutine zbflin(x1,y1,z1,x2,y2,z2)
      real, intent (in) :: x1,y1,z1,x2,y2,z2
    end subroutine zbflin

    subroutine zbftri(x,y,z,ic)
      real, dimension (3), intent (in) :: x,y,z
      integer, dimension (3), intent (in) :: ic
    end subroutine zbftri

    subroutine zscale(a,e)
      real, intent (in) :: a,e
    end subroutine zscale
 
! ================================= ZBFINI ==============================

    subroutine zbfini(iret)
      integer, intent (out) :: iret
    end subroutine zbfini

    subroutine zbffin()
    end subroutine zbffin

  end interface
end module dislin_mod3
